Package org.apache.commons.math3.geometry.spherical.oned

# Class ArcsSet

java.lang.Object
org.apache.commons.math3.geometry.partitioning.AbstractRegion<Sphere1D,Sphere1D>
org.apache.commons.math3.geometry.spherical.oned.ArcsSet

All Implemented Interfaces:
  `Iterable<double[]>`, `Region<Sphere1D>`

public class ArcsSet extends AbstractRegion<Sphere1D,Sphere1D> implements Iterable<double[]>
This class represents a region of a circle: a set of arcs.

Note that due to the wrapping around \(2 \pi\), barycenter is ill-defined here. It was defined only in order to fulfill the requirements of the `Region` interface, but its use is discouraged.

Since:
  3.3

## Nested Class Summary

Nested Classes
Modifier and Type
Class
Description
`static class`
`ArcsSet.InconsistentStateAt2PiWrapping`
Specialized exception for inconsistent BSP tree state inconsistency.
`static class`
`ArcsSet.Split`
Class holding the results of the `split` method.

## Nested classes/interfaces inherited from interface org.apache.commons.math3.geometry.partitioning.Region

`Region.Location`

## Constructor Summary

Constructors
Constructor
Description
`ArcsSet(double tolerance)`
Build an arcs set representing the whole circle.
`ArcsSet(double lower, double upper, double tolerance)`
Build an arcs set corresponding to a single arc.
`ArcsSet(Collection<SubHyperplane<Sphere1D>> boundary, double tolerance)`
Build an arcs set from a Boundary REPresentation (B-rep).
`ArcsSet(BSPTree<Sphere1D> tree, double tolerance)`
Build an arcs set from an inside/outside BSP tree.

## Method Summary

Modifier and Type
Method
Description
`List<Arc>`
`asList()`
Build an ordered list of arcs representing the instance.
`ArcsSet`
`buildNew(BSPTree<Sphere1D> tree)`
Build a region using the instance as a prototype.
`protected void`
`computeGeometricalProperties()`
Compute some geometrical properties.
`Iterator<double[]>`
`iterator()`
`BoundaryProjection<Sphere1D>`
`projectToBoundary(Point<Sphere1D> point)`
Project a point on the boundary of the region.
`Side`
`side(Arc arc)`
Deprecated.
as of 3.6, replaced with `split(Arc)`.`ArcsSet.Split.getSide()`
`ArcsSet.Split`
`split(Arc arc)`
Split the instance in two parts by an arc.

### Methods inherited from class org.apache.commons.math3.geometry.partitioning.AbstractRegion

`applyTransform, checkPoint, checkPoint, checkPoint, checkPoint, contains, copySelf, getBarycenter, getBoundarySize, getSize, getTolerance, getTree, intersection, isEmpty, isEmpty, isFull, isFull, setBarycenter, setBarycenter, setSize, side`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface java.lang.Iterable

`forEach, spliterator`

## Constructor Details

### ArcsSet

public ArcsSet(double tolerance)
Build an arcs set representing the whole circle.

Parameters:
  `tolerance` - tolerance below which close sub-arcs are merged together

### ArcsSet

public ArcsSet(double lower, double upper, double tolerance) throws NumberIsTooLargeException
Build an arcs set corresponding to a single arc.

If either `lower` is equals to `upper` or the interval exceeds \( 2 \pi \), the arc is considered to be the full circle and its initial defining boundaries will be forgotten. `lower` is not allowed to be greater than `upper` (an exception is thrown in this case).

Parameters:
  `lower` - lower bound of the arc
  `upper` - upper bound of the arc
  `tolerance` - tolerance below which close sub-arcs are merged together
Throws:
  `NumberIsTooLargeException` - if lower is greater than upper

### ArcsSet

public ArcsSet(BSPTree<Sphere1D> tree, double tolerance) throws ArcsSet.InconsistentStateAt2PiWrapping
Build an arcs set from an inside/outside BSP tree.

The leaf nodes of the BSP tree must have a `Boolean` attribute representing the inside status of the corresponding cell (true for inside cells, false for outside cells). In order to avoid building too many small objects, it is recommended to use the predefined constants `Boolean.TRUE` and `Boolean.FALSE`

Parameters:
  `tree` - inside/outside BSP tree representing the arcs set
  `tolerance` - tolerance below which close sub-arcs are merged together
Throws:
  `ArcsSet.InconsistentStateAt2PiWrapping` - if the tree leaf nodes are not consistent across the \( 0, 2 \pi \) crossing

### ArcsSet

public ArcsSet(Collection<SubHyperplane<Sphere1D>> boundary, double tolerance) throws ArcsSet.InconsistentStateAt2PiWrapping
Build an arcs set from a Boundary REPresentation (B-rep).

The boundary is provided as a collection of `sub-hyperplanes`. Each sub-hyperplane has the interior part of the region on its minus side and the exterior on its plus side.

The boundary elements can be in any order, and can form several non-connected sets (like for example polygons with holes or a set of disjoints polyhedrons considered as a whole). In fact, the elements do not even need to be connected together (their topological connections are not used here). However, if the boundary does not really separate an inside open from an outside open (open having here its topological meaning), then subsequent calls to the `checkPoint` method will not be meaningful anymore.

If the boundary is empty, the region will represent the whole space.

Parameters:
  `boundary` - collection of boundary elements
  `tolerance` - tolerance below which close sub-arcs are merged together
Throws:
  `ArcsSet.InconsistentStateAt2PiWrapping` - if the tree leaf nodes are not consistent across the \( 0, 2 \pi \) crossing

## Method Details

### buildNew

public ArcsSet buildNew(BSPTree<Sphere1D> tree)
Build a region using the instance as a prototype.

This method allow to create new instances without knowing exactly the type of the region. It is an application of the prototype design pattern.

The leaf nodes of the BSP tree must have a `Boolean` attribute representing the inside status of the corresponding cell (true for inside cells, false for outside cells). In order to avoid building too many small objects, it is recommended to use the predefined constants `Boolean.TRUE` and `Boolean.FALSE`. The tree also must have either null internal nodes or internal nodes representing the boundary as specified in the `getTree` method).

Specified by:
  `buildNew` in interface `Region<Sphere1D>`
Specified by:
  `buildNew` in class `AbstractRegion<Sphere1D,Sphere1D>`
Parameters:
  `tree` - inside/outside BSP tree representing the new region
Returns:
  the built region

### computeGeometricalProperties

protected void computeGeometricalProperties()
Compute some geometrical properties.

The properties to compute are the barycenter and the size.

Specified by:
  `computeGeometricalProperties` in class `AbstractRegion<Sphere1D,Sphere1D>`

### projectToBoundary

public BoundaryProjection<Sphere1D> projectToBoundary(Point<Sphere1D> point)
Project a point on the boundary of the region.

Specified by:
  `projectToBoundary` in interface `Region<Sphere1D>`
Overrides:
  `projectToBoundary` in class `AbstractRegion<Sphere1D,Sphere1D>`
Parameters:
  `point` - point to check
Returns:
  projection of the point on the boundary
Since:
  3.3

### asList

public List<Arc> asList()
Build an ordered list of arcs representing the instance.

This method builds this arcs set as an ordered list of `Arc` elements. An empty tree will build an empty list while a tree representing the whole circle will build a one element list with bounds set to \( 0 and 2 \pi \).

Returns:
  a new ordered list containing `Arc` elements

### iterator

public Iterator<double[]> iterator()

The iterator returns the limit angles pairs of sub-arcs in trigonometric order.

The iterator does not support the optional `remove` operation.

Specified by:
  `iterator` in interface `Iterable<double[]>`

### side

@Deprecated public Side side(Arc arc)
Deprecated.
as of 3.6, replaced with `split(Arc)`.`ArcsSet.Split.getSide()`
Compute the relative position of the instance with respect to an arc.

The `Side.MINUS` side of the arc is the one covered by the arc.

Parameters:
  `arc` - arc to check instance against
Returns:
  one of `Side.PLUS`, `Side.MINUS`, `Side.BOTH` or `Side.HYPER`

### split

public ArcsSet.Split split(Arc arc)
Split the instance in two parts by an arc.

Parameters:
  `arc` - splitting arc
Returns:
  an object containing both the part of the instance on the plus side of the arc and the part of the instance on the minus side of the arc